QGIS Application - Bug report #15723
Labels not showing when adding them using Python
2016-10-19 04:28 AM - Casper Bargesen

Status: Closed

Priority: Normal

Assignee:

Category: PyQGIS Console

Affected QGIS version:master_2 Regression?: No
Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 23645
Description

| have a simple vector polygon layer with one feature. Using python | create a simple label displaying the area of the feature.

Expected result:
A square with a label saying "1".

Actual result:
A square without a label.

Try:

Right click the layer and select properties. Click the apply button and the label is now being shown. Since no changes were made in the
properties window, | would expect the label not to be shown if this was not a bug. But since the label was shown by pressing the apply
button without any changes made to the properties, it seems to me that it is a bug.

Question:
Why is the label not shown using the below code?

Affects:
| have tested the code using QGIS 2.14.7, 2.16.1, master_2 (7396370) on Windows 7 x64, and a recent master_2 on Ubuntu x64.

from qgis.core import *

layer = QgsVectorLayer('Polygon’, 'my layer', 'memory')
QgsMapLayerRegistry.instance().addMapLayer(layer, True)

geom = QgsGeometry.fromWkt('POLYGON((00,01,11,10,00))")
feature = QgsFeature()

feature.setGeometry(geom)

layer.startEditing()

layer.addFeature(feature)

layer.commitChanges()

label = QgsPalLayerSettings()
label.readFromLayer(layer)
label.enabled = True
label.fieldName = 'round($area,0)
label.drawlLabels = True
label.writeToLayer(layer)

History
#1 - 2016-10-26 12:14 AM - Casper Borgesen

Can | ask someone to change the Category from "PyQGIS Console" to "Python plugins and bindings" since | think that label is more exact?

| don't seem to have the necessary rights to change my own issues.

#2 - 2017-05-01 01:02 AM - Giovanni Manghi

- Easy fix? set to No

- Regression? set to No

#3 - 2019-03-09 03:51 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:
http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-Itr/
